
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>扩展KMP模板 / 憋错料</title>

    <meta name="description" content="扩展KMP模板 扩展KMP:    给出模板串A和子串B,长度分别为lenA和lenB,要求在线性时间内,对于每个A[i](0 &lt;= i &lt; lenA),求出A[i..lenA-1]与B的最长公共前缀长度,记为ex[i](或者说,ex[i]为满足A[i..i + z - 1]==B[0 .. z - 1]的最大的z值).    扩展KMP可以用来解决很多字符串问题,如求一个字符串的最长回文子串和最长重复子串.[算法]    设next[i]为满足B[i..i + z - 1] == B[0..z - ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">扩展KMP模板</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>扩展KMP：<br /></strong>&nbsp;&nbsp;&nbsp; 给出模板串A和子串B，长度分别为lenA和lenB，要求在线性时间内，对于每个A[i]（0 &lt;= i &lt; lenA)，求出A[i..lenA-1]与B的最长公共前缀长度，记为ex[i]（或者说，ex[i]为满足A[i..i + z - 1]==B[0 .. z - 1]的最大的z值）。<br />&nbsp;&nbsp;&nbsp; 扩展KMP可以用来解决很多字符串问题，如求一个字符串的最长回文子串和最长重复子串。<br /><strong>【算法】<br /></strong>&nbsp;&nbsp;&nbsp; 设next[i]为满足B[i..i + z - 1] == B[0..z - 1]的最大的z值（也就是B的自身匹配）。<br />&nbsp;&nbsp;&nbsp; 设目前next[0..lenB - 1]与ex[0..i - 1]均已求出，要用它们来求ex[i]的值。<br />&nbsp;&nbsp;&nbsp; 设p为目前A串中匹配到的最远位置，k为让其匹配到最远位置的值（或者说，k是在0 &lt;= i0 &lt; i的所有i0值中，使i0 + ex[i0] - 1的值最大的一个，p为这个最大值，即k + ex[k] - 1），显然，p之后的所有位都是未知的，也就是目前还无法知道A[p + 1..lenA - 1]中的任何一位和B的任何一位是否相等。<br />&nbsp;&nbsp;&nbsp; 根据ex的定义可得，A[k..p] == B[0..p - k]，因为i &gt; k，所以又有A[i..p] == B[i - k..p - k]，设L = next[i - k]，则根据next的定义有B[0..L - 1] == B[i - k..i - k + L - 1]。<br />&nbsp;&nbsp;&nbsp; 考虑i - k + L - 1与p - k的关系：</p>
<p><strong>（1）i - k + L - 1 &lt; p - k，即i + L &lt;= p。<br /></strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 这时，由A[i..p] == B[i - k..p - k]可以得到A[i..i + L - 1] == B[i - k..i - k + L - 1]，又因为B[0..L - 1] == B[i - k..i - k + L - 1]所以A[i..i + L - 1] == B[0..L - 1]，这就说明ex[i] &gt;= L。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 又由于next的定义可得，A[i + L]必然不等于B[L]（否则A[i..i + L]==B[0..L]，因为i+L&lt;=p，所以A[i..i + L] == B[i - k..i - k + L]，这样B[0..L] == B[i - k..i - k + L]，故next[i - k]的值应为L + 1或更大），这样，可以直接得到ex[i] = L！</p>
<p><strong>（2）i + k - L + 1 &gt;= p - k，即i + L &gt; p。<br /></strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 这时，首先可以知道A[i..p]和B[0..p - i]是相等的（因为A[i..p] == B[i - k..p - k]，而i + k - L + 1 &gt;= p - k，由B[0..L - 1] == B[i - k..i - k + L - 1]可得B[0..p - i] == B[i - k..p - k]，即A[i..p] == B[0..p - i]），然后，对于A[p + 1]和B[p - i + 1]是否相等，目前是不知道的（因为前面已经说过，p是目前A串中匹配到的最远位置，在p之后无法知道任何一位的匹配信息），因此，要从A[p + 1]与B[p - i + 1]开始往后继续匹配（设j为目前B的匹配位置的下标，一开始j = p - i + 1，每次比较A[i + j]与B[j]是否相等，直到不相等或者越界为止，此时的j值就是ex[i]的值）。在这种情况下，p的值必然会得到延伸，因此更新k和p的值。<br />&nbsp;&nbsp;&nbsp; <br />&nbsp;&nbsp;&nbsp; <strong>边界：</strong>ex[0]的值需要预先求出，然后将初始的k设为0，p设为ex[0]-1。<br />&nbsp;&nbsp;&nbsp; 对于求next数组，也是“自身匹配”，类似KMP的方法处理即可。唯一的不同点也在边界上：可以直接知道next[0] = lenB，next[1]的值预先求出，然后初始k = 1，p = ex[1]。<br />&nbsp;&nbsp;&nbsp; <br />&nbsp;&nbsp;&nbsp; 严重注意：在上述的情况（2）中，本该从A[p + 1]与B[p - i + 1]开始匹配，但是，若p + 1 &lt; i，也就是p - i + 1 &lt; 0（这种情况是有可能发生的，当ex[i - 1] = 0，且前面的ex值都没有延伸到i及以后的时候）的话，需要将A、B的下标都加1（因为此时p必然等于i - 2，如果A、B的下标用两个变量x、y控制的话，x和y都要加1）！！</p>
<hr>
<p>模板代码：</p>
<blockquote><p>#include &lt;iostream&gt;<br />#include &lt;cstring&gt;</p>
<p>using namespace std;</p>
<p>const int n = 500004;<br />int next[n];<br />int extend[n];<br />char S[n];<br />char T[n];</p>
<p>void GetNext(char* T)<br />{<br />&nbsp;&nbsp;&nbsp; int k = 0;<br />&nbsp;&nbsp;&nbsp; int Tlen = strlen(T);<br />&nbsp;&nbsp;&nbsp; next[0] = Tlen;<br />&nbsp;&nbsp;&nbsp; while(k &lt; Tlen - 1 &amp;&amp; T[k] == T[k + 1])<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; k++;<br />&nbsp;&nbsp;&nbsp; next[1] = k;<br />&nbsp;&nbsp;&nbsp; k = 1;<br />&nbsp;&nbsp;&nbsp; for(int i = 2; i &lt; Tlen; i++)<br />&nbsp;&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; int p = k + next[k] - 1, L = next[i - k];<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if(i + L - 1 &gt;= p)<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; int j = (p - i + 1) &gt; 0 ? p - i + 1 : 0;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; while(i + j &lt; Tlen &amp;&amp; T[i + j] == T[j]) <br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; j++;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; next[i] = j;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; k = i;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; else next[i] = L;<br />&nbsp;&nbsp;&nbsp; }<br />}</p>
<p>void GetExtend(char* S, char* T)<br />{<br />&nbsp;&nbsp;&nbsp; int k = 0;<br />&nbsp;&nbsp;&nbsp; GetNext(T);<br />&nbsp;&nbsp;&nbsp; int Slen = strlen(S);<br />&nbsp;&nbsp;&nbsp; int Tlen = strlen(T);<br />&nbsp;&nbsp;&nbsp; int MinLen = Slen &lt; Tlen ? Slen : Tlen;<br />&nbsp;&nbsp;&nbsp; while(k &lt; MinLen &amp;&amp; S[k] == T[k])<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; k++;<br />&nbsp;&nbsp;&nbsp; extend[0] = k;<br />&nbsp;&nbsp;&nbsp; k = 0;<br />&nbsp;&nbsp;&nbsp; for(int i = 1; i &lt; Slen; i++)<br />&nbsp;&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; int p = k + extend[k] - 1, L = next[i - k];<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; if(i + L - 1 &gt;= p)<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; int j = (p - i + 1) &gt; 0 ? p - i + 1 : 0;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; while(i + j &lt; Slen &amp;&amp; j &lt; Tlen &amp;&amp; S[i + j] == T[j])<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; j++;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; extend[i] = j;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; k = i;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; else extend[i] = L;<br />&nbsp;&nbsp;&nbsp; }<br />}</p></blockquote>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-19 17:24:34 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>扩展KMP模板的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/412QJgM.html" rel="bookmark">HDU 6153 A Secret（扩展KMP模板题）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				A Secret Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 256000/256000 K (Java/Others) Total Submission(s): 2523    Accepted Submission(s): 934 Problem Description Today is the birthday of SF,so VS gives two strings S1,S2 to SF as a present,w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/9MBPoq3.html" rel="bookmark">扩展kmp 模板</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#include&lt;iostream&gt; #include&lt;string&gt; using namespace std; const int MM=100005; int next[MM],extand[MM]; char S[MM],T[MM]; void GetNext(const char *T){ int len=strlen(T),a=0; next[0]=len; while(a&lt;len-1 &amp;&amp; T[a]==T[a+1]) a++; next[1]=a;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZbdmD3.html" rel="bookmark">HDU 2594 扩展kmp模板题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目大意: 给定两个字符串,在第一个字符串中找到一个最大前缀作为第二个字符串的后缀 1 #include &lt;iostream&gt; 2 #include &lt;cstdio&gt; 3 #include &lt;cstring&gt; 4 #include &lt;algorithm&gt; 5 #include &lt;vector&gt; 6 #include &lt;queue&gt; 7 #include &lt;climits&gt; 8 #include &lt;cmath&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pGAoy3.html" rel="bookmark">&lbrack;目前未找到题目&rsqb;扩展KMP模板</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				procedure build_next; begin lena:=length(a);lenb:=length(b); next[0]:=lenb;next[1]:=lenb-1; for i:=1 to lenb-1 do if b[i]&lt;&gt;b[i+1] then begin next[1]:=i;break; end; k:=1; for i:=2 to lenb do begin p:=k+next[k]-1;L:=next[i-k]; if i+L&lt;=p then next[i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KjKr9M.html" rel="bookmark">KMP、扩展KMP、Manacher模板</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				推导过程推荐看这篇: KMP模板: 1 void init(){ 2 int j = nex[0] = -1, i = 0; 3 int len = strlen(str); 4 while(i &lt; len){ 5 if(j == -1 || str[i] == str[j]){ 6 nex[++i] = ++j; 7 }else j = nex[j]; 8 } 9 } 10 int KMP(){ 11 int i = 0, j = 0, sum = 0; 12 int len = strlen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aPy1nM.html" rel="bookmark">（模板）扩展kmp算法（luoguP5410）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接:https://www.luogu.org/problem/P5410 题意:有两个字符串a,b,要求输出b与a的每一个后缀的最长公共前缀.输出: 第一行有lenb个数,为b的next数组(特别地,next1为lenb) 第二行有lena个数,即答案. 思路:扩展kmp模板,涉及字典树,后续再补,先放模板. AC code: #include&lt;bits/stdc++.h&gt; #define N 1000010 using namespace std; int q,nxt[N],exte			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NXg1J0.html" rel="bookmark">HDU 6153 A Secret（扩展kmp）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				A Secret Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 256000/256000 K (Java/Others)Total Submission(s): 1530    Accepted Submission(s): 570 Problem Description Today is the birthday of SF,so VS gives two strings S1,S2 to SF as a present,wh			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBmoeA4.html" rel="bookmark">Part&period;5【马拉车&amp;amp&semi;扩展KMP】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Manacher(马拉车)是一种求最长回文串的线性算法,复杂度O(n).网上对其介绍的资料已经挺多了的,请善用搜索引擎. 而扩展KMP说白了就是是求模式串和主串的每一个后缀的最长公共前缀[KMP更像是一个自动机] 题目: POJ 1159: Palindrome 求原字符串最少增加几个字符后可变成回文串,相当于求最长回文子序列的长度. 解法:直接求串S和反转串Sr的最长公共子序列. #include &lt;cstdlib&gt; #include &lt;cstdio&gt; #include &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0byGrkM.html" rel="bookmark">KMP与扩展KMP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文转自:http://www.cppblog.com/MatoNo1/archive/2011/04/17/144390.aspx KMP:给出两个字符串A(称为模板串)和B(称为子串),长度分别为lenA和lenB,要求在线性时间内,对于每个A[i] (0&lt;=i&lt;lenA),求出A[i]往前和B的前缀匹配的最大匹配长度,记为ex[i](或者说,ex[i]为满足A[i- z+1..i]==B[0..z-1]的最大的z值).KMP的主要目的是求B是不是A的子串,以及若是,B在A中所有出现的位置			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0Kp5w3.html" rel="bookmark" class="title">cocoa pods</a>
					<div>
						cocoa pods CocoaPods 是 iOS 最常用最有名的类库管理工具 作为 iOS 程序员,掌握 CocoaPods 的使用是必不可少的基本技能 pod 命令汇总 # 创建默认的 Podf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYDYk0.html" rel="bookmark" class="title">DT大数据梦工厂 第72，73讲</a>
					<div>
						王家林亲授&lt;DT大数据梦工厂&gt;大数据实战视频“Scala深入浅出实战经典”视频.音频和PPT下载!第72讲:Scala界面事件处理编程实战详解百度云:http://pan.baidu.co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0byQqoM.html" rel="bookmark" class="title">C语言中数学相关知识点</a>
					<div>
						快速求幂取模 积的取余等于取余的积取余 代码如下: int pow(int a,int n,int b)//返回值是a的n次方对b取余后的值 {     int result=1;     a=a%b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dxqXB0.html" rel="bookmark" class="title">大作文如何跨越&OpenCurlyDoubleQuote;三类文&rdquo;这道坎</a>
					<div>
						一.大作文评分规则:    大作文评分不同于按点赋分的客观题,大作文评分是按档评分的,这里不过多介绍.感性了解一下大作文评分情况:评分分4档,对应40分.跑题者4档:0-10分,答题一般者3档:10- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP81xBM.html" rel="bookmark" class="title">无边框对话框的缩放</a>
					<div>
						1.        添加WM_NCHITTEST消息 2.        设置对话框属性System Menu 为False. 如果不设置添加完代码以后对话框边框出现了箭头,但是窗口大小是固定的. 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QAx2N4.html" rel="bookmark" class="title">C&plus;&plus; Primer学习总结 第5章 语句</a>
					<div>
						第5章 语句 1.    switch中的case标签必须是整型常量表达式,不能是变量也不能是非整型: 注意第二个case 3.14 在C++11中没错误可以执行,但是在C++98中编译不通过. 2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORe1r0.html" rel="bookmark" class="title">为什么驾校用车都是桑塔纳和捷达？</a>
					<div>
						话说你曾经在驾校学车的时候用的是什么车呢?目前,驾校用的车大部分都是桑塔纳和捷达,这又是为什么呢?这两款车也是目前我们国内保有量最大的车型,为什么这两款车会成为驾校专用车呢? 1,价格低 人们在买车都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDrp873.html" rel="bookmark" class="title">用css样式和div画出田字格</a>
					<div>
						&lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Strict//EN&quot; &quot;http://www.w3.org/TR/xht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZEkB4.html" rel="bookmark" class="title">开发总结--表单之验证</a>
					<div>
						关于表单验证,网上很多,但是真正自己写的时候问题很多,所以这时你就需要一个适合新学者的表单验证方法,能让你快速的进行验证,不必要去摘抄别人自己都看不懂的代码,下面就为大家来总结几个常见的简单易上手的验 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022Ee20.html" rel="bookmark" class="title">javaScript与MVC</a>
					<div>
						MVC,就是Module,View,Controller分离,使业务逻辑更加清晰,但是现在公司的项目中很多地方那个不是这样的,很多业务逻辑放在了javascript中实现,这样做的优点就是对于技术要求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzE8pk4.html" rel="bookmark" class="title">LeetCode（36）Valid Sudoku</a>
					<div>
						题目 Determine if a Sudoku is valid, according to: Sudoku Puzzles - The Rules. The Sudoku board could  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ydkpM.html" rel="bookmark" class="title">&lbrack;c&sol;c&plus;&plus;奇技淫巧&rsqb;不用循环判断输出5到1</a>
					<div>
						偶尔看到的一道题,和哥们几个讨论了一下,这玩意,不是循环就是递归了么,当然,只要达到目的,管他什么循环递归,对吧.现在总结一下我们能想到的所有的方法,大家有新的想法欢迎跟帖讨论~~ ok,开工. 第一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38pgvA3.html" rel="bookmark" class="title">NodeJS学习资料合集</a>
					<div>
						1. 官网 nodejs 2.  How do I get started with Node.js,stackoverflow提问,收集很多有用的站点 3.  node-books,github收集 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWqZg63.html" rel="bookmark" class="title">JSON 值转换</a>
					<div>
						1 var Txt = '{&quot;a&quot;:&quot;1&quot;,&quot;b&quot;:&quot;5&quot;,&quot;c&quot;:&quot;5&quot;,&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBB913.html" rel="bookmark" class="title">vs2010隐藏一段代码</a>
					<div>
						#region #隐藏后注释名 #endregion using System; using System.Collections.Generic; using System.ComponentMod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J92LA3.html" rel="bookmark" class="title">qt运行库</a>
					<div>
						KERNEL32.DLL MINGWM10.DLL MSVCRT.DLL LIBGCC_S_DW2-1.DLL QTCORE4.DLL QTGUI4.DLL 笔者安装的是QT SDK.(发行版本这是前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXlRJGM.html" rel="bookmark" class="title">Android 使用图片异步加载框架Universal Image Loader的问题</a>
					<div>
						使用的Jar包 问题:        optionsm = new DisplayImageOptions.Builder() .displayer(new RoundedBitmapDisplaye ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJKya3.html" rel="bookmark" class="title">到了我们这个年龄</a>
					<div>
						岁月如同指尖握不住的流砂悄然滑走,转眼人到中年.纵然青春不再,人生却正灿烂.如同秋风吹过山峦,红了果实,黄了绿叶喜忧参半. 到了这个年龄,对年轻人来说,我们老了,对老年人来说我们还年轻.我们担负着承上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVQ9oQ4.html" rel="bookmark" class="title">CPU高获取其线程ID然后分析</a>
					<div>
						以我们最近出现的一个实际故障为例,介绍怎么定位和解决这类问题. clip_image002 根据top命令,发现PID为28555的Java进程占用CPU高达200%,出现故障. 通过ps aux | ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4N1ELB3.html" rel="bookmark" class="title">Spring注解&commat;PostConstruct与&commat;PreDestroy</a>
					<div>
						关于在spring  容器初始化 bean 和销毁前所做的操作定义方式有三种: 第一种:通过@PostConstruct 和 @PreDestroy 方法 实现初始化和销毁bean之前进行的操作 第二 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
